exec("./Support_RaycastingWeapons.cs");

%error = ForceRequiredAddOn("Vehicle_Stunt_Plane");
if(%error == $Error::AddOn_Disabled)
{
   stuntplaneVehicle.uiName = "";
}
else if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Vehicle_Combat_Biplane - required add-on Vehicle_Stunt_Plane not found");
   return;
}

%error = ForceRequiredAddOn("Vehicle_Tank");
if(%error == $Error::AddOn_Disabled)
{
   TankVehicle.uiName = "";
}
else if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Vehicle_Combat_Biplane - required add-on Vehicle_Tank not found");
   return;
}

%error = ForceRequiredAddOn("Weapon_Gun");
if(%error == $Error::AddOn_Disabled)
{
   GunItem.uiName = "";
}
else if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Vehicle_Combat_Biplane - required add-on Weapon_Gun not found");
   return;
}

%error = ForceRequiredAddOn("Weapon_Rocket_Launcher");
if(%error == $Error::AddOn_Disabled)
{
   rocketLauncherItem.uiName = "";
}
else if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Vehicle_Combat_Biplane - required add-on Weapon_Rocket_Launcher not found");
   return;
}

datablock AudioProfile(combatBiplaneIdleSound)
{
   filename    = "./idle.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(combatBiplaneFlySound)
{
   filename    = "./flyloop.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(combatBiplaneShotSound)
{
   filename    = "./fire3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(combatBiplaneEngineOnSound)
{
   filename    = "./engineon.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(combatBiplaneEngineOffSound)
{
   filename    = "./engineoff.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock ProjectileData(combatBiplaneExplosionProjectile : tankshellProjectile)
{
   explosion           = tankShellExplosion;

   directDamageType  = $DamageType::VehicleExplosion;
   radiusDamageType  = $DamageType::VehicleExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 0;

   uiName = "";
};

datablock ParticleData(combatbiplaneShotParticle)
{
    dragCoefficient      = 0;
    gravityCoefficient   = -0.5;
    inheritedVelFactor   = 0.2;
    constantAcceleration = 0.0;
    lifetimeMS           = 40;
    lifetimeVarianceMS   = 0;
    textureName          = "base/data/particles/star1";
    spinSpeed        = 10.0;
    spinRandomMin        = -500.0;
    spinRandomMax        = 500.0;

    colors[0]     = "0.9 0.9 0 0.3";
    colors[1]     = "1 0.5 0.2 0.5";
    colors[2]     = "1 0.5 0.2 0.0";

    sizes[0]      = 3.55;
   sizes[1]      = 0.80;
    sizes[2]      = 0.10;

   times[0] = 0.0;
   times[1] = 0.1;
   times[2] = 1.0;

    useInvAlpha = false;
};
datablock ParticleEmitterData(combatbiplaneShotEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 106.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "combatbiplaneShotParticle";
};

datablock WheeledVehicleData(combatBiplaneVehicle : stuntplaneVehicle)
{
   shapeFile = "./valkyrie1.dts";

	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 7;         // Far distance from vehicle
	cameraOffset = 4.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.2;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

   numMountPoints = 1;
   
   numWheels = 3;

	// Rigid Body
	mass = 200;
	density = 5.0;
	drag = 0.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 3000; //4000;       // Engine power
	engineBrake = 1000;         // Braking when throttle is 0
	brakeTorque = 5000;        // When brakes are applied
	maxWheelSpeed = 40;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

   isSled = false;

   forwardThrust		= 2500;
	reverseThrust		= 1400;
	lift			= 110;
	maxForwardVel		= 50;
	maxReverseVel		= 50;
	horizontalSurfaceForce	= 130;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 130; 
	rollForce		= 8500;
	yawForce		= 6500;
	pitchForce		= 6500;
	rotationalDrag		= 0.4;
	stallSpeed		= 30;
   burnTime = 0;

   uiName = "Combat Biplane";

//  initialExplosionProjectile = combatBiplaneExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 0;

  finalExplosionProjectile = vehicleFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now

	minExplosionspeed = 14;
};

datablock ShapeBaseImageData(combatBiplaneLeftMachineGunImage : gunImage)
{
   shapeFile = "base/data/shapes/empty.dts";

   mountPoint = 1;

   stateTimeoutValue[2] = 0.06;
   stateSound[2] = combatBiplaneShotSound;
   stateEmitter[2] = combatBiplaneShotEmitter;

   stateTransitionOnTimeout[3] = "Ready";

    casing = GunShellDebris;
    shellExitDir        = "0 -3 2.6";
    shellExitOffset     = "0 0.2 0";
    shellExitVariance   = 15.0;    
    shellVelocity       = 7.0;


   raycastWeaponRange = 300;
   raycastSpreadAmt = 0.0011;
   raycastWeaponTargets = $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::FXBrickObjectType;
   raycastExplosionProjectile = gunProjectile;
   raycastExplosionBrickSound = gunHitSound;
   raycastExplosionPlayerSound = gunHitSound;
   raycastDirectDamage = 15;
   raycastDirectDamageType = combatBiplaneDirect;
   raycastExplosionSound = gunHitSound;
};

datablock ShapeBaseImageData(combatBiplaneRightMachineGunImage : combatBiplaneLeftMachineGunImage)
{
   mountPoint = 2;
};

datablock ShapeBaseImageData(combatBiplaneMissileImage : rocketLauncherImage)
{
   shapeFile = "base/data/shapes/empty.dts";

   mountPoint = 4;
};

function combatBiplaneVehicle::onAdd(%this, %obj)
{ 	
   Parent::onAdd(%this, %obj);

   %obj.mountImage(combatBiplaneMissileImage, 1);
   %obj.mountImage(combatBiplaneLeftMachineGunImage, 2);
   %obj.mountImage(combatBiplaneRightMachineGunImage, 3);

   %obj.prop = "off";
   soiCheck(%obj);
}

function soiCheck(%obj)
{
   if(!isObject(%obj))
      return;

   %speed = vectorLen(%obj.getVelocity());
   if(%speed < %obj.dataBlock.minContrailSpeed)
   {
      if(%obj.getMountedImage(0) !$= "")
         %obj.unMountImage(0);
   }
   else
   {
      %obj.mountImage(ContrailImage2, 0);
   }

   if(%speed < 1 && %obj.getMountedObject(0) == 0)
   {
      if(%obj.prop !$= "off")
      {
         %obj.stopThread(0);
         %obj.playAudio(0, combatBiplaneEngineOffSound);
         %obj.prop = "off";
      }
   }
   else if(%speed < 29)
   {
      if(%obj.prop !$= "slow")
      {
         %obj.playThread(0, prop_slow);
         %obj.playAudio(0, combatBiplaneIdleSound);
         %obj.prop = "slow";
      }
   }
   else 
   {
      if(%obj.prop !$= "fast")
      {
         %obj.playThread(0, prop_fast);
         %obj.playAudio(0, combatBiplaneFlySound);
         %obj.prop = "fast";
      }
   }

   schedule(1000, 0, "soiCheck", %obj);
}

function combatBiplaneVehicle::onTrigger(%this, %obj, %triggerNum, %val)
{ 	
   if(%triggerNum == 2)
      %obj.setImageTrigger(1, %val);
}

function WheeledVehicle::isFirstPerson(%this, %obj)
{
   return false;
}

function combatBiplaneVehicle::onImpact(%this, %obj, %data)
{
   %speed = vectorLen(%obj.getVelocity());
   if(%speed < %obj.dataBlock.minExplosionSpeed)
      return;

   %p = new Projectile()
   {
      dataBlock = combatBiplaneExplosionProjectile;
      initialPosition = %obj.getPosition();
      client = %obj.lastDamageClient;
      sourceClient = %obj.lastDamageClient;
   };
   MissionCleanup.add(%p);

   if(%obj.destroyed)
      return;

   %obj.setDamageLevel(%this.maxDamage);
   %obj.destroyed = 1;
   %obj.schedule(%this.burnTime, "finalExplosion");
   if(isObject(%obj.spawnBrick.client.minigame))
      %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
   %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
}

function combatBiplaneVehicle::onDriverLeave(%this, %obj)
{
   %obj.client = "";
   Parent::onDriverLeave(%this, %obj);
}

package soiPackage
{
   function Armor::onMount(%this,%obj,%col,%slot)
   {
      Parent::onMount(%this, %obj, %col, %slot);

      if(%col.getDataBlock() == combatBiplaneVehicle.getId())
      {
         %col.client = %obj.client;

         %speed = vectorLen(%col.getVelocity());
         if(%speed < 1)
            %col.playAudio(0, combatBiplaneEngineOnSound);
      }
   }

   function Armor::onTrigger(%this, %obj, %triggerNum, %val)
   {
      %mount = %obj.getObjectMount();
      if(isObject(%mount) && %mount.getDatablock() == combatBiplaneVehicle.getID() && %triggerNum == 0)
      {
         %mount.setImageTrigger(2, %val);
         %mount.setImageTrigger(3, %val);
      }

      Parent::onTrigger(%this, %obj, %triggerNum, %val);
   }
};
activatePackage(soiPackage);
